
#include <stdio.h>
#include <string.h>

#include "menustruct.h"


// next class:  menubutton

menubutton::menubutton()
{
  next=NULL;
}

void menubutton::setlabel(char *string)
{
  label = strdup(string);
}

void menubutton::setproc(char *string)
{
  data = strdup(string);
}

void menubutton::settype(int _type)
{
  type = _type;
}


// next class:  main_menu_struct

main_menu_struct::main_menu_struct()
{
  name=NULL;
  next=NULL;
  child=NULL;
}

main_menu_struct::main_menu_struct(char *_name)
{
  name=strdup(_name);
  next=NULL;
  child=NULL;
}


void main_menu_struct::sub(int *_child)
{
  child=_child;
}
    
void main_menu_struct::settext(char *_text)
{
  text=strdup(_text);
}
    
    
// next class:  sub_menu_struct

sub_menu_struct::sub_menu_struct()
{
  text=NULL;
  next=NULL;
  child=NULL;
  first_button=NULL;
  icon=NULL;
}

sub_menu_struct::sub_menu_struct(char *_text, int _type,
    char *_iconname, char *_function)
{
  text    =strdup(_text);
  bitmap  =strdup(_iconname);
  function=strdup(_function);
  next=NULL;
  child=NULL;
  type=_type;
  icon=NULL;
}

void sub_menu_struct::sub(main_menu_struct *_child)
{
  child=_child;
}
    
void sub_menu_struct::settext(char *_text)
{
  text=strdup(_text);
}

void sub_menu_struct::seticon(char *_text)
{
  bitmap=strdup(_text);
}

void sub_menu_struct::create_icon(Display *display, Window window)
{
  if (bitmap!=NULL)
    icon=new menu_icon(display, window, bitmap);
}

int sub_menu_struct::gettitlewidth(XFontStruct* font)
{
  int textwidth=XTextWidth(font, text, strlen(text));  
  return textwidth+(2*TITLE_GAP);
}

